
.code

er_func proc logLevel:DWORD,pMsg:DWORD				; logging function
	
;	PrintDec logLevel
	PrintStringByAddr pMsg
	ret
	
er_func endp

POP3SSL proc uses ebx edi esi
	invoke WSAStartup,202h,offset wsadata			; init sockets
	test eax,eax
	jne @err3
	
	invoke socket,AF_INET,SOCK_STREAM,0				; create a socket
	cmp eax,INVALID_SOCKET
	je @err2
	mov s,eax
	
	invoke setsockopt,s,SOL_SOCKET,SO_RCVTIMEO,offset timeout,sizeof timeout
	cmp eax,SOCKET_ERROR							; set timeout
	je @err2
	
	PrintStringByAddr offset _server
	PrintDec _port
	
	invoke gethostbyname,offset _server
	mov edx,eax
	mov eax,[eax+12]
	mov eax,[eax]
	mov eax,[eax]
	mov sin.sin_addr,eax
	
;	mov ax,[edx].hostent.h_addr
;	mov sin.sin_family,ax
	mov sin.sin_family,AF_INET
	
	invoke htons,_port
	mov sin.sin_port,ax
	
	;----- connect to host
	invoke connect,s,offset sin,sizeof sin
	cmp eax,SOCKET_ERROR
	jne @F
	invoke WSAGetLastError
	cmp eax,WSAEWOULDBLOCK							; skip the WSAEWOULDBLOCK error
	jne @err2
@@:
	mov fset.fd_count,1
	push s
	pop fset.fd_array
	
;	invoke CyaSSL_Debugging_ON						; optionally turn logging on
;	invoke CyaSSL_SetLoggingCb,offset er_func
	
	invoke CyaSSL_Init								; CyaSSL init stuff
	test eax,eax
	jne @err2
	
	invoke CyaSSLv3_client_method
	mov meth,eax
	
	invoke CyaSSL_CTX_new,meth
	mov ctx,eax
	
	
	;========= This will disable certification checking
	invoke CyaSSL_CTX_set_verify,ctx,SSL_VERIFY_NONE,0
	
;	;========= Check certificate
;	invoke CyaSSL_CTX_set_verify,ctx,SSL_VERIFY_PEER,0
;	;========= Gmail certificate
;	invoke CyaSSL_CTX_load_verify_locations,ctx,offset _cert1,0

	; any additional CA files should be placed in the "cert" folder
	; keep in mind that all certs need to be in PEM format
	; they can be exported from the browser, but it can be a bit tricky to find out the right certificate
	
	invoke CyaSSL_new,ctx
	mov ssl,eax
	invoke CyaSSL_set_fd,ssl,s
	
;	invoke CyaSSL_check_domain_name,ssl,offset _server		; additional check, to see if the domain matches CA
;	invoke CyaSSL_connect,ssl								; not explicitely needed, the first read call will do that for us
;	invoke CyaSSL_get_error,ssl,eax
;	invoke CyaSSL_ERR_error_string,eax,offset err_buf
	
	invoke GlobalAlloc,GPTR,POP3_BUFFER
	mov edi,eax
	
	PrintText "1"
	
	;---------- read greeting message
	call ReadSSL
	test eax,eax
	je @err4
	
	PrintText "2"
	
	;---------- send user name, read response
	invoke select,0,0,offset fset,0,0
	
	invoke szappend,edi,offset POP3_user,0
	invoke szappend,edi,offset _username,eax
	invoke szappend,edi,offset sNewLine,eax
	
	PrintStringByAddr edi
	invoke CyaSSL_write,ssl,edi,eax
	cmp eax,-1
	je @err4
	call ReadSSL
	test eax,eax
	je @err4
	
	PrintText "3"
	
	;---------- send password, read response
	invoke select,0,0,offset fset,0,0
	
	invoke szappend,edi,offset POP3_pass,0
	invoke szappend,edi,offset _password,eax
	invoke szappend,edi,offset sNewLine,eax
	
	PrintStringByAddr edi
	invoke CyaSSL_write,ssl,edi,eax
	cmp eax,-1
	je @err4
	call ReadSSL
	test eax,eax
	je @err4
	
	PrintText "4"
	
	;---------- send stat command, read response
	invoke select,0,0,offset fset,0,0
	invoke CyaSSL_write,ssl,offset POP3_stat,sizeof POP3_stat
	cmp eax,-1
	je @err4
	call ReadSSL
	test eax,eax
	je @err4
	
	PrintText "5"
	
	;----- parse number of messages
	push edi
	invoke InString,1,edi,offset sSpace
	add edi,eax
	invoke InString,1,edi,offset sSpace
	mov byte ptr[edi+eax-1],0
	invoke atodw,edi
	mov esi,eax			; number of messages
	invoke MessageBox,hWnd,edi,offset number_of_messages,0
	pop edi
	
	PrintText "6"
	
	PrintDec esi,"number of message"
	test esi,esi
	je @none
	
	PrintText "7"
	
@read:
	;---------- read top message
	invoke select,0,0,offset fset,0,0
	
	invoke szappend,edi,offset POP3_retr,0
	push eax									; szappend call
	invoke dwtoa,esi,offset number				; convert number of messages to ascii
	push offset number							; szappend call
	push edi									; szappend call
	call szappend
	invoke szappend,edi,offset sNewLine,eax
	
	invoke CyaSSL_write,ssl,edi,eax
	cmp eax,-1
	je @err4
	
	PrintText "8"
	
	invoke select,0,0,offset fset,0,0
	push edi
	xor eax,eax
	mov ebx,POP3_BUFFER
	push ebx
@@:
	add edi,eax
	sub ebx,eax
	invoke CyaSSL_read,ssl,edi,ebx
	PrintDec eax
	cmp eax,-1
	jne @B
	invoke CyaSSL_read,ssl,edi,ebx			; this was sort of a way to read the whole message
	PrintDec eax							; probably should have been done properly
	cmp eax,-1								; but it seems to work OK
	jne @B									; basically I wanted to confirm the -1 response to be sure you read everything
	
	PrintText "9"
	
	pop eax
	pop edi
	sub eax,ebx
	mov byte ptr[edi+eax],0
;	PrintDec eax
	
	;---------- display read message
	invoke DialogBoxParam,hInstance,IDD_MESSAGE,hWnd,offset MessageProc,edi
	
@quit:
	;---------- send quit message, read logoff message
	invoke select,0,0,offset fset,0,0
	invoke CyaSSL_write,ssl,offset POP3_quit,sizeof POP3_quit
	cmp eax,-1
	je @err4
	call ReadSSL
	test eax,eax
	je @err4
	
@exit3:
	invoke GlobalFree,edi
	invoke CyaSSL_shutdown,ssl
	invoke CyaSSL_free,ssl
	invoke CyaSSL_CTX_free,ctx
	
;	invoke CyaSSL_Debugging_OFF
	
	PrintText "14"
	
@exit2:
	invoke closesocket,s
@exit1:
	invoke WSACleanup
@exit:
	mov eax,esi								; 1: token found;	0: token not found
	PrintHex eax
	ret
	
@err1:
	PrintText "access error"
	mov esi,2
	jmp @exit2
	
@err2:
	PrintText "connection error"
	mov esi,2
	jmp @exit1
	
@err3:
	PrintText "socket error"
	mov esi,2
	jmp @exit
	
@err4:
	PrintText "ssl error"
	mov esi,3
	jmp @exit3
	
@none:
	PrintText "no messages"
	xor esi,esi
	jmp @quit
	
POP3SSL endp

ReadSSL proc							; used for reading
	invoke select,0,0,offset fset,0,0
	invoke CyaSSL_read,ssl,edi,POP3_BUFFER
	PrintHex eax,"read"
	push eax
	invoke CyaSSL_get_error,ssl,eax
	invoke CyaSSL_ERR_error_string,eax,offset err_buf
	PrintStringByAddr offset err_buf
	pop eax
	cmp eax,-1
	je @err1
	
	mov byte ptr[edi+eax],0
	PrintStringByAddr edi
	mov dx,word ptr[edi]
	cmp dx,resp_ok
	jne @err1
	
	;mov eax,1
	ret
@err1:
	xor eax,eax
	ret
	
ReadSSL endp

DeleteSSL proc							; used for deleting messages
	invoke select,0,0,offset fset,0,0
	invoke szappend,edi,offset POP3_dele,0
	push eax
	invoke dwtoa,esi,offset number
	push offset number
	push edi
	call szappend
	invoke szappend,edi,offset sNewLine,eax
	invoke CyaSSL_write,ssl,edi,eax
	cmp eax,-1
	je @err1
	call ReadSSL
	test eax,eax
	je @err1
	
	;mov eax,1
	ret
@err1:
	xor eax,eax
	ret
	
DeleteSSL endp

MessageProc proc uses ebx edi esi hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM			; dialog box function for displaying message contents
	mov eax,uMsg
	cmp eax,WM_INITDIALOG
	je @init
	cmp eax,WM_COMMAND
	je @command
@exit:
	xor eax,eax
	ret
	
;----------
@init:
	invoke SetDlgItemText,hDlg,ID_MESSAGE,lParam
	mov eax,TRUE
	ret
	
;========== 
@command:
	mov eax,wParam
	mov edx,eax
	shr edx,16
	cmp edx,BN_CLICKED
	jne @exit
	
	cmp ax,ID_MSG_CLOSE
	je @close
	jmp @exit
	
@close:
	invoke EndDialog,hDlg,0
	jmp @exit

MessageProc endp
